class TurokRWInterface {
    static FPSMAX { 0 }
    static FPS60 { 1 }
    static FPS30 { 2 }
    static FPS15 { 3 }
    static FPS60SCALE { 120 }
    static FPS30SCALE { 60 }
    static FPS15SCALE { 30 }
    static pCPlayerPointer { 0x8013EF84 }
}

class CGameObjectInstance {
    construct new() {
        _base = 0
    }

    construct new(b_) {
        _base = b_
    }

    base { _base }
    base=(rhs) { _base = rhs }

    m_Type { base }
    m_vPos { base + 0x08}
    m_vVelocity { base + 0x1C }
    m_vScale { base + 0x50 }
    m_Rot { base + 0x5C }
    m_RotY { base + 0x6C }
    m_vPos2 { base + 0xA4 }
    getEnd { base + 0x2E8 }
}

class CPlayer {
    construct new() {
        _base = 0
        _ca = CGameObjectInstance.new()
        _wa = CGameObjectInstance.new()
    }

    construct new(b_) {
        _base = b_
        _ca = CGameObjectInstance.new(b_)
        _wa = CGameObjectInstance.new(b_ + 0x2E8)
    }

    base { _base }
    base=(rhs) { _base = rhs }

    character { _ca }
    character=(rhs) {_ca = rhs}

    weapon { _wa }
    weapon=(rhs) {_wa = rhs}

    ca { base }
    wa { base + 0x2E8 }
    m_bActive { base + 0x5D0 }
    m_nController { base + 0x5D4 }
    m_pOptions { base + 0x5D8 }
    m_pCamera { base + 0x5DC }
    m_Speed { base + 0x6C0 }
    m_SideSpeed { base + 0x6C4 }
    m_TotalSpeed { base + 0x6C8 }
    m_YVelLastFrame { base + 0x6CC }
    m_bOnGround { base + 0x6D0 }
    m_BurstSpeed { base + 0x6D4 }
    m_BurstSideSpeed { base + 0x6D8 }
    m_BurstTimer { base + 0x6DC }
    m_DuckOffset { base + 0x718 }
    m_bDuckMode { base + 0x71C }
    unk_yOffset { base + 0x720 }
    m_vHeadRotOffset { base + 0x724 }
    m_vHeadWobbleRotOffset { base + 0x730 }
    m_vEyeOffset { base + 0x73C }
    m_RequestedWeapon { base + 0x771 }
}



